Subject: tcp_sacktag_one() WARNING (was Re: 2.6.24-rc4-mm1)

From: Cedric Le Goater <[email-masked]>
Date: Thu, 13 Dec 2007 18:38:40 +0100

Cedric Le Goater wrote:
> Ilpo Järvinen wrote:
>> On Wed, 5 Dec 2007, Andrew Morton wrote:
>>
>>> On Thu, 06 Dec 2007 17:59:37 +1100 Reuben Farrelly <[email-masked]> wrote:
>>>
>>>> This non fatal oops which I have just noticed may be related to this change then 
>>>> - certainly looks networking related.
>>> yep, but it isn't e1000.  It's core TCP.
>>>
>>>> WARNING: at net/ipv4/tcp_input.c:2518 tcp_fastretrans_alert()
>>>> Pid: 0, comm: swapper Not tainted 2.6.24-rc4-mm1 #1
>>> Ilpo, Reuben's kernel is talking to you ;)
>> ...Please try the patch below. Andrew, this probably fixes your problem 
>> (the packets <= tp->packets_out) as well.
> 
> nah. I got the WARNINGs again with this patch.

I got this new one on a 2.6.24-rc5-mm1. It looked similar ? 

C.

WARNING: at /home/legoater/linux/2.6.24-rc5-mm1/net/ipv4/tcp_input.c:1280 tcp_sacktag_one()
Pid: 0, comm: swapper Not tainted 2.6.24-rc5-mm1 #1

Call Trace:
 <IRQ>  [<ffffffff80410e0e>] tcp_sacktag_walk+0x2bc/0x62a
 [<ffffffff80411711>] tcp_sacktag_write_queue+0x595/0xa7c
 [<ffffffff8028ce66>] kfree+0xd4/0xe0
 [<ffffffff80411e9f>] tcp_ack+0x2a7/0xfc7
 [<ffffffff80252ca1>] mark_held_locks+0x47/0x6a
 [<ffffffff80252e5c>] trace_hardirqs_on+0xfe/0x139
 [<ffffffff80415d59>] tcp_rcv_established+0x66a/0x76d
 [<ffffffff8041bd35>] tcp_v4_do_rcv+0x37/0x3aa
 [<ffffffff8041e623>] tcp_v4_rcv+0x9a9/0xa76
 [<ffffffff80401832>] ip_local_deliver_finish+0x161/0x23c
 [<ffffffff80401d47>] ip_local_deliver+0x72/0x77
 [<ffffffff8040168d>] ip_rcv_finish+0x371/0x3b5
 [<ffffffff80401ca1>] ip_rcv+0x292/0x2c6
 [<ffffffff803e2aae>] netif_receive_skb+0x267/0x340
 [<ffffffff8806eff4>] :tg3:tg3_poll+0x5d2/0x89e
 [<ffffffff803e505c>] net_rx_action+0xd5/0x1ad
 [<ffffffff8023b0b9>] __do_softirq+0x5f/0xe3
 [<ffffffff8020c8ec>] call_softirq+0x1c/0x28
 [<ffffffff8020e7b9>] do_softirq+0x39/0x9f
 [<ffffffff8023b058>] irq_exit+0x4e/0x50
 [<ffffffff8020e900>] do_IRQ+0xb7/0xd7
 [<ffffffff8020a892>] mwait_idle+0x0/0x52
 [<ffffffff8020bbe6>] ret_from_intr+0x0/0xf
 <EOI>  [<ffffffff8024d0cb>] __atomic_notifier_call_chain+0x20/0x83
 [<ffffffff8020a8da>] mwait_idle+0x48/0x52
 [<ffffffff80209e79>] enter_idle+0x22/0x24
 [<ffffffff8020a822>] cpu_idle+0xa1/0xc5
 [<ffffffff8021e755>] start_secondary+0x3b9/0x3c5